unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, TeeSurfa, ExtCtrls, TeeProcs, Chart, StdCtrls, Vcl.Buttons,
  Vcl.Menus, FLEdit;

Type
  TTriVals = record
    X,Y,Z : extended;
  end;

  TTriValsArray = Array of TTriVals;


type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TContourSeries;
    Panel1: TPanel;
    CheckBox_fill: TCheckBox;
    Button_LCWData: TButton;
    Button_TestSamplesselfcreated: TButton;
    Button3: TButton;
    CheckBox_smooth: TCheckBox;
    Button_AS_samples: TButton;
    Series4: TIsoSurfaceSeries;
    BB_save: TBitBtn;
    CB_AutomaticLevels: TCheckBox;
    FLE_Levels: TFloatEdit;
    L_Levels: TLabel;
    procedure FormShow(Sender: TObject);
    procedure CheckBox_fillClick(Sender: TObject);
    procedure Button_LCWDataClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button_AS_samplesClick(Sender: TObject);
    procedure btn1Exit(Sender: TObject);
    procedure a1Click(Sender: TObject);
    procedure BB_saveClick(Sender: TObject);
    procedure CB_AutomaticLevelsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FLE_LevelsChange(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure Load_Values;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
uses IAT_String, IAT_JustSet_Komps;

{$R *.dfm}
var SampleVals : TTriValsArray;
    Vals : TTriValsArray;


procedure TForm1.Load_Values;
var i : integer;
    sl : TStrings;
    slRow : TStrings;
    x : double;
    xx : TColor;
begin
  Series1.clear;
  Series4.clear;

  sl := TStringlist.create;
  slRow := TStringlist.create;
  try
      sl.loadfromfile('.\LCW-Values.txt');

      setlength(Vals, sl.count);

      for i := 0 to sl.count -1 do
      begin
        zerlegestringfast1(sl[i], ';', slRow);
        Vals[i].X := strtofloatdef(slRow[0], 0);
        Vals[i].Y := strtofloatdef(slRow[1], 0);
        Vals[i].Z := strtofloatdef(slRow[2], 0);
      end;
  finally
    sl.free;
    slRow.free;
  end;

  //showmessage(inttostr(length(Vals)));
  for i := 0 to high(Vals) do
  begin
    Series1.AddXYZ(round(Vals[i].X), Vals[i].Z, round(Vals[i].Y));
    Series4.AddXYZ(round(Vals[i].X), Vals[i].Z, round(Vals[i].Y));
  end;
end;


{-------------------------------------------------------------------------------
  Author:    as (2012.02.06)
  Comment:
-------------------------------------------------------------------------------}
procedure TForm1.FLE_LevelsChange(Sender: TObject);
begin
   Series1.NumLevels := FLE_Levels.AsInteger;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Series1.NumLevels := 12;
  FLE_Levels.Value := Series1.NumLevels;
end;

procedure TForm1.FormShow(Sender: TObject);
var i : integer;
begin
  JustSetCheckBox(CheckBox_fill, Series1.Brush.Style = bsSolid);
  Series1.FillSampleValues(10);
  Chart1.Repaint;

  setlength(SampleVals, Series1.XValues.count -1);
  for i := 0 to high(SampleVals) do
  begin
    SampleVals[i].X := Series1.XValues.Items[i];
    SampleVals[i].Y := Series1.YValues.Items[i];
    SampleVals[i].Z := Series1.ZValues.Items[i];
  end;
end;

{-------------------------------------------------------------------------------
  Author:    as (2012.02.08)
  Comment:
-------------------------------------------------------------------------------}
procedure TForm1.CB_AutomaticLevelsClick(Sender: TObject);
begin
   Button_LCWDataClick(Button_LCWData);
end;

procedure TForm1.CheckBox_fillClick(Sender: TObject);
begin
  If Sender = CheckBox_fill then
  begin
    If CheckBox_fill.checked then
      Series1.Brush.Style := bsSolid
    else
      Series1.Brush.Style := bsClear;

    Series4.Brush.Style := Series1.Brush.Style;
  end;

  If Sender = CheckBox_smooth then
  begin
    Series1.Smoothing.Active:=CheckBox_smooth.Checked;
    //Series4.Smoothing.Active:=Series1.Smoothing.Active;
  end;
end;

{-------------------------------------------------------------------------------
  Author:    as (2012.02.06)
  Comment:
-------------------------------------------------------------------------------}
procedure TForm1.Button_LCWDataClick(Sender: TObject);
var i : Integer;
begin
  //********************************************************************************
  // 1)
  If Sender = Button_LCWData then
  begin
    Chart1.LeftAxis.Automatic := False;
    Chart1.BottomAxis.Automatic := False;

    Chart1.LeftAxis.Minimum := 0;
    Chart1.LeftAxis.Maximum := 1337.5;

    Chart1.BottomAxis.Minimum := -1000;
    Chart1.BottomAxis.Maximum := +1000;

    if CB_AutomaticLevels.Checked then
      Series1.AutomaticLevels := True
    else
    begin
      for i := 0 to Series1.Levels.Count -1 do
        Series1.Levels[i].UpToValue := i * 5;
      Series1.AutomaticLevels := False;
    end;

    Load_Values; // Keine Farbe bei TChart 2011 weil X und Z Dezimalzahelen sind (Y Wert (Level) darf Dezimal sein)
  end;
  //********************************************************************************
  // 2)
  If Sender = Button_TestSamplesselfcreated then
  begin
    Chart1.LeftAxis.Automatic := True;
    Chart1.BottomAxis.Automatic := True;

    Series1.AutomaticLevels := True;

    Series1.clear;
    Series1.FillSampleValues(10);

    Series4.clear;
    Series4.FillSampleValues(10);
    //showmessage('X : ' + inttostr(Series1.XValues.count) + '; Y : ' + inttostr(Series1.YValues.count) + '; Z : ' + inttostr(Series1.ZValues.count));
  end;

end;
{-------------------------------------------------------------------------------
  Author:    as (2012.02.08)
  Comment:
-------------------------------------------------------------------------------}
procedure TForm1.a1Click(Sender: TObject);
begin
  ShowMessage('y<ccx');
end;

procedure TForm1.BB_saveClick(Sender: TObject);
begin
   Chart1.SaveToBitmapFile('d:\Temp\TChart.bmp');
end;

procedure TForm1.btn1Exit(Sender: TObject);
begin
  ShowMessage('hallo');
end;

procedure TForm1.Button3Click(Sender: TObject);
var i : integer;
    Arow : integer;
    sl : TStrings;
begin
  ARow := -1;
  Series1.clear;
  Chart1.LeftAxis.Automatic := True;
  Chart1.BottomAxis.Automatic := True;
  Series1.AutomaticLevels := True;


  sl := TStringlist.create;
  try
      //showmessage(inttostr(length(SampleVals)));

      {for i := 0 to high(SampleVals) do
        Series1.AddXYZ(SampleVals[i].X, SampleVals[i].Y, SampleVals[i].Z);  }
      for i := 0 to 10 do //high(SampleVals) do
      begin
        //If Odd(i) then
        begin
          inc(ARow);
          Series1.AddXYZ(SampleVals[i].X, SampleVals[i].Y, SampleVals[i].Z);

          sl.add(formatfloat('0.000', SampleVals[i].X) + ';' +
                 formatfloat('0.000', SampleVals[i].Y)          + ';' +
                 formatfloat('0.000', SampleVals[i].Z));
        end;
        //Series1.AddXYZ(SampleVals[i].X, SampleVals[i].Y, SampleVals[i].Z);
      end;

      for i := 100 to 110 do //high(SampleVals) do
      begin
        //If Odd(i) then
        begin
          inc(ARow);
          Series1.AddXYZ(SampleVals[i].X, SampleVals[i].Y, SampleVals[i].Z);

          sl.add(formatfloat('0.000', SampleVals[i].X) + ';' +
                 formatfloat('0.000', SampleVals[i].Y)          + ';' +
                 formatfloat('0.000', SampleVals[i].Z));
        end;
        //Series1.AddXYZ(SampleVals[i].X, SampleVals[i].Y, SampleVals[i].Z);
      end;
      sl.savetofile('.\Chart_SampleVals.txt');
  finally
    sl.free;
  end;
end;



procedure TForm1.Button_AS_samplesClick(Sender: TObject);
var i,j : integer;
begin
  Chart1.LeftAxis.Automatic := True;
  Chart1.BottomAxis.Automatic := True;
  Series1.AutomaticLevels := True;


  Series1.IrregularGrid := true;
  Series1.clear;

  // Problem : Wird bei x Oder Z Dezimalzahlen eingegeben so weichen die Farbbereiche von den Linien ab
  Series1.AddXYZ( 1.000, 0.496, 1.000);
  Series1.AddXYZ( 2.000, 0.493, 1.000);
  Series1.AddXYZ( 3.000, 0.487, 1.000);

  Series1.AddXYZ( 1.000, 0.490, 2.000);   //100
  Series1.AddXYZ( 2.000, 0.485, 2.000);   //101
  Series1.AddXYZ( 3.000, 0.480, 2.000);
//or even worser!
//  Series1.AddXYZ( 2.000, 0.386, 2.000);   //101
//  Series1.AddXYZ( 3.000, 0.382, 2.000);

Exit;

  Series1.AddXYZ(100, 0, 100);
  Series1.AddXYZ(100, 0, 200);
  Series1.AddXYZ(100, 0, 300);
  Series1.AddXYZ(100, 0, 400);

  Series1.AddXYZ(200, 1, 100);
  Series1.AddXYZ(200, 1, 200);
  Series1.AddXYZ(200, 1, 300);
  Series1.AddXYZ(200, 1, 400);

  Series1.AddXYZ(300, 2, 100);
  Series1.AddXYZ(300, 2, 200);
  Series1.AddXYZ(300, 2, 300);
  Series1.AddXYZ(300, 2, 400);
end;

end.
